;--------------------------------

; The stuff to install

Section /o java SEC00
 Call DetectJRE
SectionEnd


; weird: when section "data" is before "adaba", copying of directories works as expected
; when the order is reversed, "data" does not copy
;
; this seems only to be the case when the script is compiled on ferrari

Section !adaba SEC01
  SectionIn RO

  SetOutPath "$INSTDIR"
  File ..\adaba.exe
  File ..\transcriber.exe
  File ..\dist\Adaba.jar
  File ..\resources\icons\adaba.ico
  File ..\resources\icons\web.ico

  SetOverwrite ifnewer
  SetOverwrite on
  File "..\doc\Readme.html"


  WriteRegStr HKLM "${PRODUCT_REGISTRY_PREF}" "ApplicationPath" "$INSTDIR"
  WriteRegStr HKCU "${PRODUCT_REGISTRY_PREF}" "ApplicationPath" "$INSTDIR"

; Shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section adaba-database SEC02
  SectionIn RO
  SetOutPath "$INSTDIR\db"
  File "..\db\db.atd"
  File "..\db\db_ortho.jdb"
  File "..\db\db_phonetic.jdb"

; Shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

; tar-support
; see http://nsis.sourceforge.net/UnTGZ_plug-in
; - get http://nsis.sourceforge.net/mediawiki/images/9/9d/Untgz.zip
; - put the "untgz.dll" into /usr/share/nsis/Plugins/
; - use!

SectionGroup "Data files" SEC03
SectionGroup "Sounds" SEC03.1
  Section "A" SEC03.1.1
        CreateDirectory "$INSTDIR\data\sounds\A"
        AddSize 108404
        File "/oname=$INSTDIR\data\sounds\A\A.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsA.tar"
  SectionEnd
  Section "" SEC03.1.2
        CreateDirectory "$INSTDIR\data\sounds\AE"
        AddSize 3624
        File "/oname=$INSTDIR\data\sounds\AE\AE.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsAE.tar"
  SectionEnd
  Section "B" SEC03.1.3
        CreateDirectory "$INSTDIR\data\sounds\B"
        AddSize 77460
        File "/oname=$INSTDIR\data\sounds\B\B.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsB.tar"
  SectionEnd
  Section "C" SEC03.1.4
        CreateDirectory "$INSTDIR\data\sounds\C"
        AddSize 18264
        File "/oname=$INSTDIR\data\sounds\C\C.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsC.tar"
  SectionEnd
  Section "D" SEC03.1.5
        CreateDirectory "$INSTDIR\data\sounds\D"
        AddSize 49696
        File "/oname=$INSTDIR\data\sounds\D\D.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsD.tar"
  SectionEnd
  Section "E" SEC03.1.6
        CreateDirectory "$INSTDIR\data\sounds\E"
        AddSize 75172
        File "/oname=$INSTDIR\data\sounds\E\E.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsE.tar"
  SectionEnd
  Section "F" SEC03.1.7
        CreateDirectory "$INSTDIR\data\sounds\F"
        AddSize 46352
        File "/oname=$INSTDIR\data\sounds\F\F.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsF.tar"
  SectionEnd
  Section "G" SEC03.1.8
        CreateDirectory "$INSTDIR\data\sounds\G"
        AddSize 63488
        File "/oname=$INSTDIR\data\sounds\G\G.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsG.tar"
  SectionEnd
  Section "H" SEC03.1.9
        CreateDirectory "$INSTDIR\data\sounds\H"
        AddSize 31776
        File "/oname=$INSTDIR\data\sounds\H\H.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsH.tar"
  SectionEnd
  Section "I" SEC03.1.10
        CreateDirectory "$INSTDIR\data\sounds\I"
        AddSize 18544
        File "/oname=$INSTDIR\data\sounds\I\I.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsI.tar"
  SectionEnd
  Section "J" SEC03.1.11
        CreateDirectory "$INSTDIR\data\sounds\J"
        AddSize 10936
        File "/oname=$INSTDIR\data\sounds\J\J.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsJ.tar"
  SectionEnd
  Section "K" SEC03.1.12
        CreateDirectory "$INSTDIR\data\sounds\K"
        AddSize 46832
        File "/oname=$INSTDIR\data\sounds\K\K.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsK.tar"
  SectionEnd
  Section "L" SEC03.1.13
        CreateDirectory "$INSTDIR\data\sounds\L"
        AddSize 30016
        File "/oname=$INSTDIR\data\sounds\L\L.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsL.tar"
  SectionEnd
  Section "M" SEC03.1.14
        CreateDirectory "$INSTDIR\data\sounds\M"
        AddSize 46524
        File "/oname=$INSTDIR\data\sounds\M\M.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsM.tar"
  SectionEnd
  Section "N" SEC03.1.15
        CreateDirectory "$INSTDIR\data\sounds\N"
        AddSize 31196
        File "/oname=$INSTDIR\data\sounds\N\N.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsN.tar"
  SectionEnd
  Section "O" SEC03.1.16
        CreateDirectory "$INSTDIR\data\sounds\O"
        AddSize 16676
        File "/oname=$INSTDIR\data\sounds\O\O.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsO.tar"
  SectionEnd
  Section "" SEC03.1.17
        CreateDirectory "$INSTDIR\data\sounds\OE"
        AddSize 3316
        File "/oname=$INSTDIR\data\sounds\OE\OE.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsOE.tar"
  SectionEnd
  Section "P" SEC03.1.18
        CreateDirectory "$INSTDIR\data\sounds\P"
        AddSize 43500
        File "/oname=$INSTDIR\data\sounds\P\P.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsP.tar"
  SectionEnd
  Section "Q" SEC03.1.19
        CreateDirectory "$INSTDIR\data\sounds\Q"
        AddSize 2164
        File "/oname=$INSTDIR\data\sounds\Q\Q.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsQ.tar"
  SectionEnd
  Section "R" SEC03.1.20
        CreateDirectory "$INSTDIR\data\sounds\R"
        AddSize 39024
        File "/oname=$INSTDIR\data\sounds\R\R.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsR.tar"
  SectionEnd
  Section "S" SEC03.1.21
        CreateDirectory "$INSTDIR\data\sounds\S"
        AddSize 112116
        File "/oname=$INSTDIR\data\sounds\S\S.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsS.tar"
  SectionEnd
  Section "T" SEC03.1.22
        CreateDirectory "$INSTDIR\data\sounds\T"
        AddSize 33732
        File "/oname=$INSTDIR\data\sounds\T\T.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsT.tar"
  SectionEnd
  Section "U" SEC03.1.23
        CreateDirectory "$INSTDIR\data\sounds\U"
        AddSize 27284
        File "/oname=$INSTDIR\data\sounds\U\U.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsU.tar"
  SectionEnd
  Section "" SEC03.1.24
        CreateDirectory "$INSTDIR\data\sounds\UE"
        AddSize 8896
        File "/oname=$INSTDIR\data\sounds\UE\UE.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsUE.tar"
  SectionEnd
  Section "V" SEC03.1.25
        CreateDirectory "$INSTDIR\data\sounds\V"
        AddSize 63328
        File "/oname=$INSTDIR\data\sounds\V\V.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsV.tar"
  SectionEnd
  Section "W" SEC03.1.26
        CreateDirectory "$INSTDIR\data\sounds\W"
        AddSize 40004
        File "/oname=$INSTDIR\data\sounds\W\W.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsW.tar"
  SectionEnd
  Section "X" SEC03.1.27
        CreateDirectory "$INSTDIR\data\sounds\X"
        AddSize 456
        File "/oname=$INSTDIR\data\sounds\X\X.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsX.tar"
  SectionEnd
  Section "Y" SEC03.1.28
        CreateDirectory "$INSTDIR\data\sounds\Y"
        AddSize 256
        File "/oname=$INSTDIR\data\sounds\Y\Y.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsY.tar"
  SectionEnd
  Section "Z" SEC03.1.29
        CreateDirectory "$INSTDIR\data\sounds\Z"
        AddSize 30848
        File "/oname=$INSTDIR\data\sounds\Z\Z.id" ..\data\adaba.id
	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\soundsZ.tar"
  SectionEnd

SectionGroupEnd

SectionGroup "Texte" SEC03.2

  Section "Texte" SEC03.2.1
        CreateDirectory "$INSTDIR\data\texts"
        AddSize 226928
        File "/oname=$INSTDIR\data\texts\texts.id" ..\data\adaba.id

	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\texts.tar"
  SectionEnd

  Section "zustzliche Texte" SEC03.2.2
        CreateDirectory "$INSTDIR\data\etexts"
        AddSize 148540
        File "/oname=$INSTDIR\data\etexts\etexts.id" ..\data\adaba.id

	untgz::extract -d "$INSTDIR\data" "$DATASOURCEDIR\dataz\etexts.tar"
  SectionEnd

 SectionGroupEnd
SectionGroupEnd

Section "Schriftarten" SEC04
  StrCpy $FONT_DIR $FONTS

  ClearErrors
  !insertmacro InstallTTF '..\share\fonts\Gentium.ttf'
  ClearErrors
  !insertmacro InstallTTF '..\share\fonts\DoulosSIL.ttf'
 
  SendMessage ${HWND_BROADCAST} ${WM_FONTCHANGE} 0 0 /TIMEOUT=5000
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section # data0
; check whether some data gets installed and make sure we do set the adaba.id and the registry correctly!
 !insertmacro SectionFlagIsSet ${SEC03} ${SF_PSELECTED} isSel chkAll
chkAll: 
 !insertmacro SectionFlagIsSet ${SEC03} ${SF_SELECTED} isSel endSel
isSel:
 CreateDirectory "$INSTDIR\data"

 SetOutPath "$INSTDIR\data"
 File "..\data\adaba.id"

 WriteRegStr HKLM "${PRODUCT_REGISTRY_PREF}" "DataPath" "$INSTDIR\data"
 WriteRegStr HKCU "${PRODUCT_REGISTRY_PREF}" "DataPath" "$INSTDIR\data"

 !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
 !insertmacro MUI_STARTMENU_WRITE_END

endSel:

SectionEnd

Section -AdditionalIcons
  SetOutPath $INSTDIR
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
; CreateShortCut link.lnk                                target.file [parameters                                 [icon.file [icon_index_number [start_options [keyboard_shortcut [description]]]]]]
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Adaba.lnk"   "$INSTDIR\adaba.exe"  "" "$INSTDIR\adaba.ico"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url" "" "$INSTDIR\web.ico"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\readme.lnk" "$INSTDIR\Readme.html"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

; Section descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC00} "adaba bentigt java>=1.5! Diese Option berprft, ob auf Ihrem Rechner eine kompatible Java-Umgebung vorahnden ist, und startet gegebenfalls eine Installation ber Ihr Netzwerk."
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} "Die Applikation zum Bedienen des sterreichischen Aussprachewrterbuchs"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} "Das sterreichische Aussprachewrterbuch"

  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03} "Audio-Daten fr das sterreichische Aussprachewrterbuch"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1} "Einzelwrter"

  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.1} "Einzelwrter Buchstabe A"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.2} "Einzelwrter Buchstabe "
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.3} "Einzelwrter Buchstabe B"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.4} "Einzelwrter Buchstabe C"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.5} "Einzelwrter Buchstabe D"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.6} "Einzelwrter Buchstabe E"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.7} "Einzelwrter Buchstabe F"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.8} "Einzelwrter Buchstabe G"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.9} "Einzelwrter Buchstabe H"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.10} "Einzelwrter Buchstabe I"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.11} "Einzelwrter Buchstabe J"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.12} "Einzelwrter Buchstabe K"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.13} "Einzelwrter Buchstabe L"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.14} "Einzelwrter Buchstabe M"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.15} "Einzelwrter Buchstabe N"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.16} "Einzelwrter Buchstabe O"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.17} "Einzelwrter Buchstabe "
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.18} "Einzelwrter Buchstabe P"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.19} "Einzelwrter Buchstabe Q"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.20} "Einzelwrter Buchstabe R"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.21} "Einzelwrter Buchstabe S"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.22} "Einzelwrter Buchstabe T"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.23} "Einzelwrter Buchstabe U"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.24} "Einzelwrter Buchstabe "
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.25} "Einzelwrter Buchstabe V"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.26} "Einzelwrter Buchstabe W"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.27} "Einzelwrter Buchstabe X"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.28} "Einzelwrter Buchstabe Y"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.1.29} "Einzelwrter Buchstabe Z"

  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.2} "geschlossene Texte"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.2.1} "geschlossene Texte"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03.2.2} "zustzliche Texte"


  !insertmacro MUI_DESCRIPTION_TEXT ${SEC04} "IPA-Fonts zur korrekten Darstellung der Transkriptionen"
!insertmacro MUI_FUNCTION_DESCRIPTION_END

Section Uninstall
  !insertmacro MUI_STARTMENU_GETFOLDER "Application" $ICONS_GROUP
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\db\db_phonetic.jdb"
  Delete "$INSTDIR\db\db_ortho.jdb"
  Delete "$INSTDIR\db\db.atd"
  Delete "$INSTDIR\Readme.html"
  Delete "$INSTDIR\web.ico"
  Delete "$INSTDIR\adaba.ico"
  Delete "$INSTDIR\Adaba.jar"
  Delete "$INSTDIR\adaba.exe"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Adaba.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Website.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\readme.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir "$INSTDIR\db"

  StrCmp $UNINST_DELDATA "no" skip_deldata
    RMDir /r "$INSTDIR\data"
  skip_deldata:

  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"

  DeleteRegKey HKLM "${PRODUCT_REGISTRY_PREF}"
  DeleteRegKey HKCU "${PRODUCT_REGISTRY_PREF}"

  SetAutoClose true
SectionEnd
