!ifndef JMZ_JAVA_INCLUDED
!define JMZ_JAVA_INCLUDED



!define JRE_VERSION "1.5"
!define JRE_URL "http://dlc.sun.com/jdk/jre-1_5_0_01-windows-i586-p.exe"

!ifndef ENSURE_JRE
 !define ENSURE_JRE
!endif


!include "WordFunc.nsh"
!insertmacro VersionCompare

Function FindJRE
;
;  Find JRE (Java.exe)
;  1 - in .\jre directory (JRE Installed with application)
;  2 - in JAVA_HOME environment variable
;  3 - in the registry
;  4 - assume java.exe in current dir or PATH
 
  Push $R0
  Push $R1
 
  ClearErrors
  StrCpy $R0 "$EXEDIR\jre\bin\javaw.exe"
  IfFileExists $R0 JreFound
  StrCpy $R0 ""
 
  ClearErrors
  ReadEnvStr $R0 "JAVA_HOME"
  StrCpy $R0 "$R0\bin\javaw.exe"
  IfErrors 0 JreFound
 
  ClearErrors
  ReadRegStr $R1 HKLM "SOFTWARE\JavaSoft\Java Runtime Environment" "CurrentVersion"
  ReadRegStr $R0 HKLM "SOFTWARE\JavaSoft\Java Runtime Environment\$R1" "JavaHome"
  StrCpy $R0 "$R0\bin\javaw.exe"
 
  IfErrors 0 JreFound
  StrCpy $R0 "javaw"
        
 JreFound:
  Pop $R1
  Exch $R0
FunctionEnd


; JAVA 1.5
; detect and get java: http://nsis.sourceforge.net/Simple_Java_Runtime_Download_Script
; call DetectJRE in the MainSection


Function GetJRE
;	Call EnsureAdministrator
        MessageBox MB_OK "${PRODUCT_LONGNAME} uses Java 1.5, it will now \
                         be downloaded and installed"
 
        StrCpy $2 "$TEMP\Java Runtime Environment.exe"
        nsisdl::download /TIMEOUT=30000 ${JRE_URL} $2
        Pop $R0 ;Get the return value
                StrCmp $R0 "success" +3
                MessageBox MB_OK "Download failed: $R0"
                Quit
	ClearErrors
        ExecWait $2

;	IfErrors 0 +3
;         MessageBox MB_OK "Please become 'Administrator' and manually run the installer: $2"
;	 Quit

        Delete $2
FunctionEnd
 
 
Function DetectJRE
  ReadRegStr $2 HKLM "SOFTWARE\JavaSoft\Java Runtime Environment" \
             "CurrentVersion"

  ${VersionCompare} "${JRE_VERSION}" "$2" $R0
  StrCmp $R0 1 +1 jre_done

  Call GetJRE

;  done:

; a second test
   ReadRegStr $2 HKLM "SOFTWARE\JavaSoft\Java Runtime Environment" \
             "CurrentVersion"

   ${VersionCompare} "${JRE_VERSION}" "$2" $R0
   StrCmp $R0 1 +1 jre_done
  
   MessageBox MB_OK "I was unable to install Java!$\nPlease manually install java (>=1.5) and re-run this installer!"
   Quit

  jre_done:
FunctionEnd



; endif JMZ_JAVA
!endif
