; Java Launcher
;--------------

!define PRODUCT_LONGNAME "adaba transcriber"

Name "adaba transcriber"
Caption "Adaba Transcriber Launcher"
Icon "..\resources\icons\adaba.ico"
OutFile "..\transcriber.exe"

!include "java.nsi"

SilentInstall silent
AutoCloseWindow true
ShowInstDetails nevershow

!define JARFILE "Adaba.jar"
!define JAVAOPTIONS "-Xms128m -Xmx240m"

Function .onInit
  ; prevent multiple instances running at the same time
  System::Call 'kernel32::CreateMutexA(i 0, i 0, t "adabaMutex") i .r1 ?e'
  Pop $R0
 
  StrCmp $R0 0 +3
   MessageBox MB_OK|MB_ICONEXCLAMATION "adaba is already running."
   Abort
FunctionEnd
 
Section ""
;  DetectJRE
  Call FindJRE
  Pop $R0
 
  ; change for your purpose (-jar etc.)
  StrCpy $0 '"$R0" ${JAVAOPTIONS} -jar ${JARFILE} --logfile=adaba.log --transcriber'
 
  SetOutPath $EXEDIR
  ExecWait $0
SectionEnd

