// AdabaResultInterface.java
// $Id: AdabaResultInterface.java 1870 2007-07-11 13:13:38Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.adaba;
import  at.iem.adaba.database.*;

public interface AdabaResultInterface {
    /**
     * the result of a search
     * @param result an array of Eintrag-Keys to be used (or <code>null</code> if the search returned no result)
     */
    void setResult(String[]result);

    /**
     * if an error occurs during search, this will be called, so the gui can tell the user...
     */
    void searchErrorCallback(Throwable e);
}
