// AdabaResultInterface.java
// $Id: AdabaResultInterface.java 1551 2007-05-19 13:13:12Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.adaba;

public interface AdabaShowResultInterface {
    /**
     * empty the list of entries in the ResultInterface and set it to the given Eintrag;
     * the Eintrag will be set active
     * @param key the new Eintrag-Key that is to be used
     */
    void show(String key);
    /**
     * empty the list of entries in the ResultInterface and set it to the given Eintrag;
     * the Eintrag specified with "index" will be set active
     * @param Eintrag an array of new Eintrag-Keys to be used
     * @param index the index of the Eintrag to be activated
     */
    void show(String[] keys, int index);

}
