// Factory.java
// $Id: Factory.java 1161 2007-01-02 15:50:12Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.adaba.database;


public class Factory {
    private Factory() {
        // this should never happen!
    }


    public static TranscriptionDataBase open(String name, String user, String passwd, boolean readonly)
    {
        TranscriptionDataBase result = null;
        try {
            result=new at.iem.adaba.database.ATD.ATDataBase(name, !readonly);
            return result;
        } catch (Exception e) {
            at.iem.tools.Logger.println("DEBUG: couldn't open database");}

        return result;
    }


}
