// AdabaVersion.java
// $Id: AdabaVersion.java 1633 2007-05-26 07:46:45Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.adaba;

/**
 * Versions-Strings
 */

public class AdabaVersion {
    private static final String revision="1967";

    private static final String AdabaVersion="1.0";

    private static final String TranscriberVersion="v0.23";


    public static String getAdabaVersion() 
    {
	return AdabaVersion+" r"+revision;
    }

    public static String getTranscriberVersion() 
    {
	return TranscriberVersion+" r"+revision;
    }

    private AdabaVersion() 
    {}
}
