// Refreshable.java
// $Id: Refreshable.java 831 2006-03-16 16:21:53Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.tools.gui;

/**
 * interface for things who want to clean up before refreshing: Refreshable
 */
public interface Refreshable {

    /** 
     * refresh the gui
     */
    public void refresh();
}
