// WAVPlayer.java
// $Id: WAVPlayer.java 519 2004-05-24 14:05:36Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the GNU General Public License (GnuGPL)
// see the LICENSE.txt file
//
// as a matter of facts, this code has just been ripped off SoundPlayer-example from the SUN-tutorials

package at.iem.tools.sound;

import java.applet.*;

public class WAVPlayer extends AbstractPlayer{
    private AudioClip clip;

  private static boolean isFirstTime=true;
    private static void firstTime(){
	if (isFirstTime){
	    System.out.println("\tWAVPlayer by zmoelnig@iem.at");
	    isFirstTime=false;
	}
    }

    public WAVPlayer(){ firstTime(); }
    
    protected boolean do_load(){
	clip = Applet.newAudioClip(SoundFile);
	return true;
    }

    public boolean play(){
	if (clip == null){
	    System.out.println("file not yet loaded....");
	    return false;
	}
	clip.stop();
	clip.play();
	return true;
    }
    public boolean pause(){
	if (clip != null)clip.stop();
	return true;
    }
}
